package cn.iocoder.yudao.module.bpm.enums.message;

import cn.hutool.core.util.ArrayUtil;
import cn.iocoder.yudao.framework.common.core.ArrayValuable;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Arrays;

/**
 * Bpm 消息类型的枚举
 *
 * @author jinyd
 */
@AllArgsConstructor
@Getter
public enum BpmMessageTypeEnum implements ArrayValuable<Integer> {

    ASSIGNED(3, "发起"),
    APPROVE(1, "同意"), //
    REJECT(2, "拒绝"); //

    public static final Integer[] ARRAYS = Arrays.stream(values()).map(BpmMessageTypeEnum::getValue).toArray(Integer[]::new);

    /**
     * 类型
     */
    private final Integer value;
    /**
     * 类型名
     */
    private final String name;

    public static BpmMessageTypeEnum valueOf(Integer value) {
        return ArrayUtil.firstMatch(bpmMessageType -> bpmMessageType.getValue().equals(value), BpmMessageTypeEnum.values());
    }

    @Override
    public Integer[] array() {
        return ARRAYS;
    }

}
